#ifndef _ISOADC12_H
#define _ISOADC12_H

#define ISOADC12_BASE (0x380)
#define ISOADC12_REG(offset) ((offset) + ISOADC12_BASE)

/* Write Register */
#define ISOADC12_ADDCMD		(ISOADC12_REG(0x0))
#define 	ISOADC12_ADDCMD_DIS	(1<<7)
/*
 * RNG | BIP | conversion range | ADDR register range
 * ----|-----|------------------|----------------------
 *   0 |   0 |   0V -  +5V      | 0x0000 - 0x0fff
 *   0 |   1 |  -5V -  +5V      | 0xf800 - 0x07ff
 *   1 |   0 |   0V - +10V      | 0x0000 - 0x0fff
 *   1 |   1 | -10V - +10V      | 0xf800 - 0x07ff
 */
#define 	ISOADC12_ADDCMD_RNG	(1<<5)
#define 	ISOADC12_ADDCMD_BIP	(1<<4)
#define 	ISOADC12_ADDCMD_CH_MASK	(0xf)
#define ISOADC12_INTMODE	(ISOADC12_REG(0x1))
#define 	ISOADC12_INTMODE_SWAP	(1<<7)
#define 	ISOADC12_INTMODE_EDGE	(1<<6)
#define 	ISOADC12_INTMODE_ADVCT	(1<<5)
#define 	ISOADC12_INTMODE_ADINT	(1<<4)
#define 	ISOADC12_INTMODE_YPOL	(1<<3)
#define 	ISOADC12_INTMODE_YINT	(1<<2)
#define 	ISOADC12_INTMODE_XPOL	(1<<1)
#define 	ISOADC12_INTMODE_XINT	(1<<0)
#define ISOADC12_LEDCTRL	(ISOADC12_REG(0x2))
#define 	ISOADC12_LEDCTRL_RDBID	(1<<7)
#define 	ISOADC12_LEDCTRL_TEST	(1<<6)
#define 	ISOADC12_LEDCTRL_LED2	(1<<5)
#define 	ISOADC12_LEDCTRL_LED1	(1<<4)
#define ISOADC12_PO		(ISOADC12_REG(0x3))

/* Read Register */
#define ISOADC12_ADDR	(ISOADC12_REG(0x0))
#define ISOADC12_STAT	(ISOADC12_REG(0x2)) /* ISOADC12_LEDCTRL_RDBID == 0 */
#define 	ISOADC12_STAT_BUSY	(1<<7)
#define 	ISOADC12_STAT_EOC	(1<<6)
#define 	ISOADC12_STAT_LEDS2	(1<<5)
#define 	ISOADC12_STAT_LEDS1	(1<<4)
#define 	ISOADC12_STAT_OPT	(1<<0)
#define ISOADC12_BID	(ISOADC12_REG(0x2)) /* ISOADC12_LEDCTRL_RDBID == 1 */
#define 	ISOADC12_BID_MPC104_ADC12	(0xa6)
#define 	ISOADC12_BID_MPC104_ADC12_16	(0xa7)
#define ISOADC12_PI	(ISOADC12_REG(0x3))

#define ISOADC12_NR_CH_ADC12	(8)
#define ISOADC12_NR_CH_ADC12_16	(16)
#define ISOADC12_NR_CH_MAX	(ISOADC12_NR_CH_ADC12_16)
#define ISOADC12_PO_MAX		(0xff)
#define ISOADC12_CONVERT_TIME	(13) /* 12.5us */
#define ISOADC12_BIP_AD_MAX	(0x07ff)

#define ISOADC12_RNG0_VMAX	(5)
#define ISOADC12_RNG1_VMAX	(10)
#define ISOADC12_BIP0_AMAX	(0xfff)
#define ISOADC12_BIP1_AMAX	(0x7ff)

#endif
